namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *concat_common_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2023-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_CONCAT_COMMON_H)==""\n"
R"==(#define GPU_INTEL_OCL_CONCAT_COMMON_H)==""\n"
R"==(#define REDUCE_STAGE_0(cat, f))==""\n"
R"==(#define REDUCE_STAGE_1(cat, f) f(0))==""\n"
R"==(#define REDUCE_STAGE_2(cat, f) cat(REDUCE_STAGE_1(cat, f), f(1)))==""\n"
R"==(#define REDUCE_STAGE_3(cat, f) cat(REDUCE_STAGE_2(cat, f), f(2)))==""\n"
R"==(#define REDUCE_STAGE_4(cat, f) cat(REDUCE_STAGE_3(cat, f), f(3)))==""\n"
R"==(#define REDUCE_STAGE_5(cat, f) cat(REDUCE_STAGE_4(cat, f), f(4)))==""\n"
R"==(#define REDUCE_STAGE_6(cat, f) cat(REDUCE_STAGE_5(cat, f), f(5)))==""\n"
R"==(#define REDUCE_STAGE_7(cat, f) cat(REDUCE_STAGE_6(cat, f), f(6)))==""\n"
R"==(#define REDUCE_STAGE_8(cat, f) cat(REDUCE_STAGE_7(cat, f), f(7)))==""\n"
R"==(#define REDUCE_STAGE_9(cat, f) cat(REDUCE_STAGE_8(cat, f), f(8)))==""\n"
R"==(#define REDUCE_STAGE_10(cat, f) cat(REDUCE_STAGE_9(cat, f), f(9)))==""\n"
R"==(#define REDUCE_STAGE_11(cat, f) cat(REDUCE_STAGE_10(cat, f), f(10)))==""\n"
R"==(#define REDUCE_STAGE_12(cat, f) cat(REDUCE_STAGE_11(cat, f), f(11)))==""\n"
R"==(#define REDUCE_STAGE_13(cat, f) cat(REDUCE_STAGE_12(cat, f), f(12)))==""\n"
R"==(#define REDUCE_STAGE_14(cat, f) cat(REDUCE_STAGE_13(cat, f), f(13)))==""\n"
R"==(#define REDUCE_STAGE_15(cat, f) cat(REDUCE_STAGE_14(cat, f), f(14)))==""\n"
R"==(#define REDUCE_STAGE_16(cat, f) cat(REDUCE_STAGE_15(cat, f), f(15)))==""\n"
R"==(#define REDUCE_STAGE_17(cat, f) cat(REDUCE_STAGE_16(cat, f), f(16)))==""\n"
R"==(#define REDUCE_STAGE_18(cat, f) cat(REDUCE_STAGE_17(cat, f), f(17)))==""\n"
R"==(#define REDUCE_STAGE_19(cat, f) cat(REDUCE_STAGE_18(cat, f), f(18)))==""\n"
R"==(#define REDUCE_STAGE_20(cat, f) cat(REDUCE_STAGE_19(cat, f), f(19)))==""\n"
R"==(#define REDUCE_STAGE_21(cat, f) cat(REDUCE_STAGE_20(cat, f), f(20)))==""\n"
R"==(#define REDUCE_STAGE_22(cat, f) cat(REDUCE_STAGE_21(cat, f), f(21)))==""\n"
R"==(#define REDUCE_STAGE_23(cat, f) cat(REDUCE_STAGE_22(cat, f), f(22)))==""\n"
R"==(#define REDUCE_STAGE_24(cat, f) cat(REDUCE_STAGE_23(cat, f), f(23)))==""\n"
R"==(#define REDUCE_STAGE_25(cat, f) cat(REDUCE_STAGE_24(cat, f), f(24)))==""\n"
R"==(#define REDUCE_STAGE_26(cat, f) cat(REDUCE_STAGE_25(cat, f), f(25)))==""\n"
R"==(#define REDUCE_STAGE_27(cat, f) cat(REDUCE_STAGE_26(cat, f), f(26)))==""\n"
R"==(#define REDUCE_STAGE_28(cat, f) cat(REDUCE_STAGE_27(cat, f), f(27)))==""\n"
R"==(#define REDUCE_STAGE_29(cat, f) cat(REDUCE_STAGE_28(cat, f), f(28)))==""\n"
R"==(#define REDUCE_STAGE_30(cat, f) cat(REDUCE_STAGE_29(cat, f), f(29)))==""\n"
R"==(#define REDUCE_STAGE_31(cat, f) cat(REDUCE_STAGE_30(cat, f), f(30)))==""\n"
R"==(#define REDUCE_STAGE_32(cat, f) cat(REDUCE_STAGE_31(cat, f), f(31)))==""\n"
R"==(#define REDUCE_STAGE_33(cat, f) cat(REDUCE_STAGE_32(cat, f), f(32)))==""\n"
R"==(#define REDUCE_STAGE_34(cat, f) cat(REDUCE_STAGE_33(cat, f), f(33)))==""\n"
R"==(#define REDUCE_STAGE_35(cat, f) cat(REDUCE_STAGE_34(cat, f), f(34)))==""\n"
R"==(#define REDUCE_STAGE_36(cat, f) cat(REDUCE_STAGE_35(cat, f), f(35)))==""\n"
R"==(#define REDUCE_STAGE_37(cat, f) cat(REDUCE_STAGE_36(cat, f), f(36)))==""\n"
R"==(#define REDUCE_STAGE_38(cat, f) cat(REDUCE_STAGE_37(cat, f), f(37)))==""\n"
R"==(#define REDUCE_STAGE_39(cat, f) cat(REDUCE_STAGE_38(cat, f), f(38)))==""\n"
R"==(#define REDUCE_STAGE_40(cat, f) cat(REDUCE_STAGE_39(cat, f), f(39)))==""\n"
R"==(#define REDUCE_STAGE_41(cat, f) cat(REDUCE_STAGE_40(cat, f), f(40)))==""\n"
R"==(#define REDUCE_STAGE_42(cat, f) cat(REDUCE_STAGE_41(cat, f), f(41)))==""\n"
R"==(#define REDUCE_STAGE_43(cat, f) cat(REDUCE_STAGE_42(cat, f), f(42)))==""\n"
R"==(#define REDUCE_STAGE_44(cat, f) cat(REDUCE_STAGE_43(cat, f), f(43)))==""\n"
R"==(#define REDUCE_STAGE_45(cat, f) cat(REDUCE_STAGE_44(cat, f), f(44)))==""\n"
R"==(#define REDUCE_STAGE_46(cat, f) cat(REDUCE_STAGE_45(cat, f), f(45)))==""\n"
R"==(#define REDUCE_STAGE_47(cat, f) cat(REDUCE_STAGE_46(cat, f), f(46)))==""\n"
R"==(#define REDUCE_STAGE_48(cat, f) cat(REDUCE_STAGE_47(cat, f), f(47)))==""\n"
R"==(#define REDUCE_STAGE_49(cat, f) cat(REDUCE_STAGE_48(cat, f), f(48)))==""\n"
R"==(#define REDUCE_STAGE_50(cat, f) cat(REDUCE_STAGE_49(cat, f), f(49)))==""\n"
R"==(#define REDUCE_STAGE_51(cat, f) cat(REDUCE_STAGE_50(cat, f), f(50)))==""\n"
R"==(#define REDUCE_STAGE_52(cat, f) cat(REDUCE_STAGE_51(cat, f), f(51)))==""\n"
R"==(#define REDUCE_STAGE_53(cat, f) cat(REDUCE_STAGE_52(cat, f), f(52)))==""\n"
R"==(#define REDUCE_STAGE_54(cat, f) cat(REDUCE_STAGE_53(cat, f), f(53)))==""\n"
R"==(#define REDUCE_STAGE_55(cat, f) cat(REDUCE_STAGE_54(cat, f), f(54)))==""\n"
R"==(#define REDUCE_STAGE_56(cat, f) cat(REDUCE_STAGE_55(cat, f), f(55)))==""\n"
R"==(#define REDUCE_STAGE_57(cat, f) cat(REDUCE_STAGE_56(cat, f), f(56)))==""\n"
R"==(#define REDUCE_STAGE_58(cat, f) cat(REDUCE_STAGE_57(cat, f), f(57)))==""\n"
R"==(#define REDUCE_STAGE_59(cat, f) cat(REDUCE_STAGE_58(cat, f), f(58)))==""\n"
R"==(#define REDUCE_STAGE_60(cat, f) cat(REDUCE_STAGE_59(cat, f), f(59)))==""\n"
R"==(#define REDUCE_STAGE_61(cat, f) cat(REDUCE_STAGE_60(cat, f), f(60)))==""\n"
R"==(#define REDUCE_STAGE_62(cat, f) cat(REDUCE_STAGE_61(cat, f), f(61)))==""\n"
R"==(#define REDUCE_STAGE_63(cat, f) cat(REDUCE_STAGE_62(cat, f), f(62)))==""\n"
R"==(#define REDUCE_STAGE_64(cat, f) cat(REDUCE_STAGE_63(cat, f), f(63)))==""\n"
R"==(#define REDUCE2(n, cat, f) REDUCE_STAGE_##n(cat, f))==""\n"
R"==(#define REDUCE(n, cat, f) REDUCE2(n, cat, f))==""\n"
R"==(#define JOIN_COMMA(x, y) x, y)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}