namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_io_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_IO_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_IO_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_conversion.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_custom_types.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_utils.h")==""\n"
R"==(#define DEF_load(dst_dt, src_dt) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(load(__private dst_dt *dst, __global src_dt *val) { \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(*val); \)==""\n"
R"==(})==""\n"
R"==(#define DEF_write(dst_dt, src_dt) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(write(__global dst_dt *dst, __private src_dt *val) { \)==""\n"
R"==(*dst = CONCAT2(into_, dst_dt)(*val); \)==""\n"
R"==(})==""\n"
R"==(DEF_load(float, float);)==""\n"
R"==(DEF_load(float, char);)==""\n"
R"==(DEF_load(float, uchar);)==""\n"
R"==(DEF_load(int, char);)==""\n"
R"==(DEF_load(int, uchar);)==""\n"
R"==(DEF_load(float, bf16);)==""\n"
R"==(DEF_write(char, float);)==""\n"
R"==(DEF_write(uchar, float);)==""\n"
R"==(DEF_write(bf16, float);)==""\n"
R"==(DEF_write(float, float);)==""\n"
R"==(DEF_write(char, int);)==""\n"
R"==(DEF_write(uchar, int);)==""\n"
R"==(DEF_write(bf16, int);)==""\n"
R"==(DEF_write(float, int);)==""\n"
R"==(#ifdef cl_khr_fp16)==""\n"
R"==(DEF_load(half, half);)==""\n"
R"==(DEF_load(float, half);)==""\n"
R"==(DEF_write(half, float);)==""\n"
R"==(DEF_write(half, int);)==""\n"
R"==(DEF_write(half, half);)==""\n"
R"==(DEF_write(char, half);)==""\n"
R"==(DEF_write(uchar, half);)==""\n"
R"==(DEF_write(float, half);)==""\n"
R"==(DEF_write(bf16, half);)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_BF8)==""\n"
R"==(DEF_load(half, f8_e5m2);)==""\n"
R"==(DEF_load(float, f8_e5m2);)==""\n"
R"==(DEF_load(half, f8_e4m3);)==""\n"
R"==(DEF_load(float, f8_e4m3);)==""\n"
R"==(DEF_write(f8_e5m2, half);)==""\n"
R"==(DEF_write(f8_e5m2, float);)==""\n"
R"==(DEF_write(f8_e5m2, int);)==""\n"
R"==(DEF_write(f8_e4m3, half);)==""\n"
R"==(DEF_write(f8_e4m3, float);)==""\n"
R"==(DEF_write(f8_e4m3, int);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef cl_khr_fp64)==""\n"
R"==(DEF_load(float, double); )==""\n"
R"==(DEF_load(double, bf16);)==""\n"
R"==(DEF_load(double, float);)==""\n"
R"==(DEF_load(double, double);)==""\n"
R"==(DEF_write(char, double);)==""\n"
R"==(DEF_write(uchar, double);)==""\n"
R"==(DEF_write(bf16, double);)==""\n"
R"==(DEF_write(float, double);)==""\n"
R"==(DEF_write(double, double);)==""\n"
R"==(DEF_write(double, float);)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(cl_khr_fp16) && defined(cl_khr_fp64))==""\n"
R"==(DEF_load(double, half);)==""\n"
R"==(DEF_write(half, double);)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_BF8)==""\n"
R"==(DEF_load(double, f8_e5m2);)==""\n"
R"==(DEF_load(double, f8_e4m3);)==""\n"
R"==(DEF_write(f8_e5m2, double);)==""\n"
R"==(DEF_write(f8_e4m3, double);)==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}