namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reusable_softmax_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(__kernel void reusable_softmax_fwd_generic(__global SRC_DATA_T *src,)==""\n"
R"==(__global DST_DATA_T *dst, __global float *src_scale,)==""\n"
R"==(__global float *dst_scale, dim_t softmax_axis_size,)==""\n"
R"==(dim_t softmax_axis_stride, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(src = GWS_GET_BUFFER_POS(SRC, gws_params, src);)==""\n"
R"==(dst = GWS_GET_BUFFER_POS(DST, gws_params, dst);)==""\n"
R"==(FLT_ACC_DATA_T max_ = TO_FLT_ACC_DATA_T(DATA_MIN);)==""\n"
R"==(FLT_ACC_DATA_T denom_ = TO_FLT_ACC_DATA_T(DATA_ZERO);)==""\n"
R"==(unroll_16_for(int c = 0; c < softmax_axis_size; c++) {)==""\n"
R"==(max_ = max(max_, TO_FLT_ACC_DATA_T(src[c * softmax_axis_stride]));)==""\n"
R"==(})==""\n"
R"==(unroll_16_for(int c = 0; c < softmax_axis_size; c++) {)==""\n"
R"==(denom_ += exp(TO_FLT_ACC_DATA_T(src[c * softmax_axis_stride]) - max_);)==""\n"
R"==(})==""\n"
R"==(denom_ = LOGSOFTMAX ? log(denom_) : 1.0f / denom_;)==""\n"
R"==(for (int c = 0; c < softmax_axis_size; c++) {)==""\n"
R"==(size_t data_off = c * softmax_axis_stride;)==""\n"
R"==(FLT_ACC_DATA_T unscaled = LOGSOFTMAX)==""\n"
R"==(? TO_FLT_ACC_DATA_T(src[data_off]) - max_ - denom_)==""\n"
R"==(: exp(TO_FLT_ACC_DATA_T(src[data_off]) - max_) * denom_;)==""\n"
R"==(float scale = 1.0f;)==""\n"
R"==(if (src_scale) { scale = *src_scale; })==""\n"
R"==(if (dst_scale) { scale /= *dst_scale; })==""\n"
R"==(dst[data_off] = TO_DST(unscaled * scale);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}